#glTF Tutorial

This tutorial gives an introduction to [glTF](https://www.khronos.org/gltf), the GL transmission format. It summarizes the most important features and application cases of glTF, and describes the structure of the files that are related to glTF. It explains how glTF files may be read, processed and used to display 3D graphics efficiently.

Some basic knowledge about [JSON](http://json.org/), the JavaScript Object Notation, and about [OpenGL](https://www.khronos.org/opengl/) is required. Where appropriate, the related concepts of OpenGL will be explained quickly, usually with examples in [WebGL](https://www.khronos.org/webgl/).

- [Introduction](gltfTutorial_001_Introduction.md)
- [Basic glTF structure](gltfTutorial_002_BasicGltfStructure.md)
- [Scene structure](gltfTutorial_003_SceneStructure.md)
- [Scenes, nodes, cameras and animations](gltfTutorial_004_ScenesNodesCamerasAnimations.md)
- [Meshes, textures, images and samplers](gltfTutorial_005_MeshesTexturesImagesSamplers.md)
- [Materials, techniques, programs and shaders](gltfTutorial_006_MaterialsTechniquesProgramsShaders.md)
- [Buffers, bufferViews and accessors](gltfTutorial_007_BuffersBufferViewsAccessors.md)
- [Skins](gltfTutorial_008_Skins.md)
- **TODO** Extensions
- [Summary](gltfTutorial_999_Summary.md) (**TODO** decide how this should be integrated) 



----------


> **TODO** :
> 
 

> - Should the text use backticking when talking about glTF elements? I.e. should it be 
>  - The `texture` refers to a `sampler` ... and the `meshPrimitive` contains ... **OR**
>  - The texture refers to a sampler ... and the mesh primitive contains ... 
>       
>       (in the first case, the plurals look ugly: `accessor`s )


> - What should be the naming pattern for the example JSON? Right now, the "user-defined" (or rather "application-defined") names are of the form `"exampleBuffer"`, `"exampleMesh"`. It could also be `"buffer0"`, `"buffer_01"` or whatever. In any case, it should be **consistent** throughout the tutorial (**TODO** Review this!!!), and likely be pointed out explicitly in the introduction!

> - Consider some shameless self-promotion of https://javagl.github.io/GLConstantsTranslator/GLConstantsTranslator.html
